diff -ruN ../nakedmudv3.7/src/interpret.c src/interpret.c
--- ../nakedmudv3.7/src/interpret.c	2008-05-31 00:17:59.000000000 -0400
+++ src/interpret.c	2009-03-02 01:09:34.000000000 -0500
@@ -12,6 +12,7 @@
 #include "room.h"
 #include "commands.h"
 #include "action.h"
+#include "hooks.h"
 
 
 
@@ -47,54 +48,81 @@
   // functions to the MUD, they should be added in the init_xxx() function
   // associated with your module.
   //***************************************************************************
-  add_cmd("back",       NULL, cmd_back,     "player", FALSE);
-  add_cmd("commands",   NULL, cmd_commands, "player", FALSE);
-  add_cmd("compress",   NULL, cmd_compress, "player", FALSE);
-  add_cmd("groupcmds",  NULL, cmd_groupcmds,"player", FALSE);
-  add_cmd("look",       "l",  cmd_look,     "player", FALSE);
-  add_cmd("more",       NULL, cmd_more,     "player", FALSE);
-  add_cmd_check("look", chk_conscious);
+  add_cmd("back",       NULL, cmd_back,        "player", FALSE);
+  add_cmd("commands",   NULL, cmd_commands,    "player", FALSE);
+  //add_cmd("compress",   NULL, cmd_compress,    "player", FALSE);
+  //add_cmd("groupcmds",  NULL, cmd_groupcmds,   "player", FALSE);
+  add_cmd("look",       "l",  cmd_look,        "player", FALSE);
+  add_cmd("more",       NULL, cmd_more,        "player", FALSE);
+  add_cmd_check("look",        chk_conscious);
 }
 
 bool cmd_exists(const char *cmd) {
   return nearMapKeyExists(cmd_table, cmd);
 }
 
-void remove_cmd(const char *cmd) {
-  CMD_DATA *old_cmd = nearMapRemove(cmd_table, cmd);
-  if(old_cmd) deleteCmd(old_cmd);
+CMD_DATA *remove_cmd(const char *cmd) {
+  return nearMapRemove(cmd_table, cmd);
 }
 
 void add_cmd(const char *cmd, const char *sort_by, COMMAND(func),
 	     const char *user_group, bool interrupts) {
-  // if we've already got a command named this, remove it
-  remove_cmd(cmd);
+  // do we already have an existing command we're just updating?
+  CMD_DATA *data = remove_cmd(cmd);
+
+  // is it something that needs to be updated or erased?
+  if(data != NULL && !cmdHasFunc(data))
+    cmdUpdate(data, func, user_group, interrupts);
+  else {
+    if(data != NULL)
+      deleteCmd(data);
+    data = newCmd(cmd, func, user_group, interrupts);
+  }
 
   // add in the new command
-  nearMapPut(cmd_table, cmd, sort_by, 
-	     newCmd(cmd, func, user_group, interrupts));
+  nearMapPut(cmd_table, cmd, sort_by, data);
 }
 
 void add_py_cmd(const char *cmd, const char *sort_by, void *pyfunc,
 	     const char *user_group, bool interrupts) {
-  // if we've already got a command named this, remove it
-  remove_cmd(cmd);
+  // do we already have an existing command we're just updating?
+  CMD_DATA *data = remove_cmd(cmd);
+
+  // is this something that needs to be updated or erased?
+  if(data != NULL && !cmdHasFunc(data))
+    cmdPyUpdate(data, pyfunc, user_group, interrupts);
+  else {
+    if(data != NULL)
+      deleteCmd(data);
+    data = newPyCmd(cmd, pyfunc, user_group, interrupts);
+  }
 
   // add in the new command
-  nearMapPut(cmd_table, cmd, sort_by, 
-	     newPyCmd(cmd, pyfunc, user_group, interrupts));
+  nearMapPut(cmd_table, cmd, sort_by, data);
 }
 
 void add_cmd_check(const char *cmd, CMD_CHK(func)) {
   CMD_DATA *data = nearMapGet(cmd_table, cmd, FALSE);
-  if(data != NULL)
-    cmdAddCheck(data, func);
+
+  // make a temp container for just the checks
+  if(data == NULL) {
+    data = newCmd(cmd, NULL, "", FALSE);
+    nearMapPut(cmd_table, cmd, NULL, data);
+  }
+    
+  cmdAddCheck(data, func);
 }
 
 void add_py_cmd_check(const char *cmd, void *pyfunc) {
   CMD_DATA *data = nearMapGet(cmd_table, cmd, FALSE);
-  if(data != NULL)
-    cmdAddPyCheck(data, pyfunc);
+
+  // make a temp container just for the checks
+  if(data == NULL) {
+    data = newCmd(cmd, NULL, "", FALSE);
+    nearMapPut(cmd_table, cmd, NULL, data);
+  }
+
+  cmdAddPyCheck(data, pyfunc);
 }
 
 // show the character all of the commands in the specified group(s).
@@ -107,7 +135,7 @@
 
   // go over all of our buckets
   ITERATE_NEARMAP(abbrev, cmd, near_i) {
-    if(is_keyword(user_groups, cmdGetUserGroup(cmd), FALSE)) {
+    if(cmdHasFunc(cmd) && is_keyword(user_groups, cmdGetUserGroup(cmd), FALSE)){
       bprintf(buf, "%-13.13s", cmdGetName(cmd));
       if (!(++col % 6))
 	bufferCat(buf, "\r\n");
@@ -115,13 +143,13 @@
   } deleteNearIterator(near_i);
 
   // do room commands as well
-  if(roomGetCmdTable(charGetRoom(ch)) != NULL) {
+  if(roomHasCmds(charGetRoom(ch))) {
     near_i = newNearIterator(roomGetCmdTable(charGetRoom(ch)));
     abbrev = NULL;
     cmd    = NULL;
     bufferCat(buf, "{c");
     ITERATE_NEARMAP(abbrev, cmd, near_i) {
-      if(is_keyword(user_groups, cmdGetUserGroup(cmd), FALSE)) {
+      if(cmdHasFunc(cmd) && is_keyword(user_groups,cmdGetUserGroup(cmd),FALSE)){
 	bprintf(buf, "%-13.13s", cmdGetName(cmd));
 	if (!(++col % 6))
 	  bufferCat(buf, "\r\n");
@@ -136,6 +164,60 @@
   deleteBuffer(buf);
 }
 
+//
+// return whether the command is usable by the character
+bool is_usable_cmd(CHAR_DATA *ch, CMD_DATA *cmd) {
+  // this is a check, not a command
+  if(*cmdGetUserGroup(cmd) == '\0')
+    return FALSE;
+  return is_keyword(bitvectorGetBits(charGetUserGroups(ch)),
+		    cmdGetUserGroup(cmd), FALSE);
+}
+
+//
+// checks are commands without a specific user group, added to finer-grain 
+// command tables (e.g., characters, to rooms, to zones, to the world). This
+// is for e.g., allowing for the addition of checks before leaving a room
+// (maybe you have to move a boulder out of the way first, etc...)
+CMD_DATA *find_check(CHAR_DATA *ch, NEAR_MAP *table, const char *name) {
+  CMD_DATA *check = nearMapGet(table, name, FALSE);
+  /*
+  if(check == NULL) || *cmdGetUserGroup(check) != '\0')
+    return NULL;
+  */
+  return check;
+}
+
+//
+// tries to find the relevant command, usable by the character
+CMD_DATA *find_cmd(CHAR_DATA *ch, NEAR_MAP *table, const char *name, 
+		   bool abbrev_ok) {
+  if(abbrev_ok == FALSE) {
+    CMD_DATA *cmd = nearMapGet(table, name, FALSE);
+    // no command exists
+    if(cmd == NULL || !is_usable_cmd(ch, cmd))
+      return NULL;
+    return cmd;
+  }
+  else {
+    // try to look up the possible commands
+    LIST *cmdname_list = nearMapGetAllMatches(table, name);
+    CMD_DATA  *cmd = NULL;
+    if(cmdname_list != NULL) {
+      LIST_ITERATOR *cmdname_i = newListIterator(cmdname_list);
+      const char      *cmdname = NULL;
+      ITERATE_LIST(cmdname, cmdname_i) {
+	cmd = nearMapGet(table, cmdname, FALSE);
+	if(is_usable_cmd(ch, cmd))
+	  break;
+	else
+	  cmd = NULL;
+      } deleteListIterator(cmdname_i);
+      deleteListWith(cmdname_list, free);
+    }
+    return cmd;
+  }
+}
 
 // tries to pull a usable command from the near-table and use it. Returns
 // TRUE if a usable command was found (even if it failed) and false otherwise.
@@ -143,36 +225,42 @@
 		       char *arg, bool abbrev_ok) {
   if(abbrev_ok == FALSE) {
     CMD_DATA *cmd = nearMapGet(table, command, FALSE);
-    if(cmd == NULL || !is_keyword(bitvectorGetBits(charGetUserGroups(ch)),
-				  cmdGetUserGroup(cmd), FALSE))
+    if(cmd == NULL)
       return FALSE;
-    else {
-      charTryCmd(ch, cmd, arg); 
+    else if(!*cmdGetUserGroup(cmd) || 
+	    is_keyword(bitvectorGetBits(charGetUserGroups(ch)),
+		       cmdGetUserGroup(cmd), FALSE)) {
+      if(charTryCmd(ch, cmd, arg) == -1)
+	return FALSE;
       return TRUE;
     }
+    else
+      return FALSE;
   }
   else {
     // try to look up the possible commands
-    LIST *cmd_list = nearMapGetAllMatches(table, command);
-    bool cmd_found = FALSE;
-    if(cmd_list != NULL) {
-      LIST_ITERATOR *cmd_i = newListIterator(cmd_list);
-      CMD_DATA        *cmd = NULL;
-      ITERATE_LIST(cmd, cmd_i) {
-	if(is_keyword(bitvectorGetBits(charGetUserGroups(ch)), 
+    LIST *cmdname_list = nearMapGetAllMatches(table, command);
+    bool           ret = FALSE;
+    if(cmdname_list != NULL) {
+      LIST_ITERATOR *cmdname_i = newListIterator(cmdname_list);
+      CMD_DATA            *cmd = NULL;
+      const char      *cmdname = NULL;
+      ITERATE_LIST(cmdname, cmdname_i) {
+	cmd = nearMapGet(table, cmdname, FALSE);
+	if(!*cmdGetUserGroup(cmd) ||
+	   is_keyword(bitvectorGetBits(charGetUserGroups(ch)), 
 		      cmdGetUserGroup(cmd), FALSE)) {
-	  charTryCmd(ch, cmd, arg); 
-	  cmd_found = TRUE;
+	  if(charTryCmd(ch, cmd, arg) != -1)
+	    ret = TRUE;
 	  break;
 	}
-      } deleteListIterator(cmd_i);
-      deleteList(cmd_list);
+      } deleteListIterator(cmdname_i);
+      deleteListWith(cmdname_list, free);
     }
-    return cmd_found;
+    return ret;
   }
 }
 
-
 void handle_cmd_input(SOCKET_DATA *dsock, char *arg) {
   CHAR_DATA *ch;
   if ((ch = socketGetChar(dsock)) == NULL)
@@ -180,7 +268,6 @@
   do_cmd(ch, arg, TRUE);
 }
 
-
 void do_cmd(CHAR_DATA *ch, char *arg, bool aliases_ok)  {
   char command[MAX_BUFFER];
 
@@ -213,9 +300,67 @@
     return;
 #endif
 
-  // first try room commands then world commands
+  // figure out what tables we need to look over
+  LIST *cmd_tables = newList();
+  // item-specific commands here? <---
+  // character-specific commands here? <---
+  if(charGetRoom(ch) && roomHasCmds(charGetRoom(ch)))
+    listQueue(cmd_tables, roomGetCmdTable(charGetRoom(ch)));
+  // zone-specific commands here? <---
+  listQueue(cmd_tables, cmd_table);
+
+  // go through each table in the list, in order. Check if the command exists
+  // in any of the tables. Only allow abbreviations in the last table (the
+  // game commands). Before a command is executed, run checks that might be
+  // included on any of the previous tables
+  int  i, j, ret;
+  bool found = FALSE;
+  for(i = 0; i < listSize(cmd_tables); i++) {
+    NEAR_MAP *table = listGet(cmd_tables, i);
+    CMD_DATA   *cmd = find_cmd(ch, table, command, 
+			       (i == listSize(cmd_tables)-1 ? TRUE : FALSE));
+    if(cmd != NULL) {
+      // first, run checks on all our previous tables
+      for(j = 0; j < i; j++) {
+	CMD_DATA *check = find_check(ch,listGet(cmd_tables,j),cmdGetName(cmd));
+	if(check != NULL) {
+	  // run the check
+	  if((ret = charTryCmd(ch, check, arg)) != -1) {
+	    if(ret == TRUE)
+	      hookRun("command", hookBuildInfo("ch str str",
+					       ch,cmdGetName(cmd),arg));
+ 	    found = TRUE;
+	    break;
+	  }
+	}
+      }
+    }
+
+    if(found == TRUE)
+      break;
+    else if(cmd != NULL) {
+      // execute the command
+      if((ret = charTryCmd(ch, cmd, arg)) != -1) {
+	if(ret == TRUE)
+	  hookRun("command",hookBuildInfo("ch str str",ch,cmdGetName(cmd),arg));
+	found = TRUE;
+	break;
+      }
+    }
+  }
+
+  // nothing usable was found
+  if(found == FALSE)
+    text_to_char(ch, "No such command.\r\n");
+
+  // garbage collection
+  deleteList(cmd_tables);
+
+  /*
+  // try the command
   if(!charGetRoom(ch) || 
      !try_use_cmd_table(ch,roomGetCmdTable(charGetRoom(ch)),command,arg,FALSE))
     if(!try_use_cmd_table(ch, cmd_table, command, arg, TRUE))
       text_to_char(ch, "No such command.\r\n");
+  */
 }
diff -ruN ../nakedmudv3.7/src/items/items.c src/items/items.c
--- ../nakedmudv3.7/src/items/items.c	2008-12-06 00:20:20.000000000 -0500
+++ src/items/items.c	2009-03-02 01:00:38.000000000 -0500
@@ -369,6 +369,19 @@
   }
 }
 
+PyObject *PyObj_get_types(PyObject *self) {  
+  // pull out the object and check the type
+  OBJ_DATA    *obj = PyObj_AsObj((PyObject *)self);
+  if(obj != NULL)
+    return Py_BuildValue("s", objGetTypes(obj));
+  else {
+    PyErr_Format(PyExc_StandardError, 
+		 "Tried to list types of nonexistent object, %d.", 
+		 PyObj_AsUid(self));
+    return NULL;
+  }
+}
+
 PyObject *PyObj_settype(PyObject *self, PyObject *args) {  
   char *type = NULL;
 
@@ -416,6 +429,8 @@
 		  "checks to see if the object is of the specified type");
   PyObj_addMethod("settype", PyObj_settype, METH_VARARGS,
 		  "the object will become of the specified type");
+  PyObj_addMethod("get_types", PyObj_get_types, METH_NOARGS,
+		  "returns a list of the types this object is");
   // do we need a deltype as well?
   //***********
   // FINISH ME
diff -ruN ../nakedmudv3.7/src/items/items.h src/items/items.h
--- ../nakedmudv3.7/src/items/items.h	2008-05-31 00:17:59.000000000 -0400
+++ src/items/items.h	2009-03-02 01:00:38.000000000 -0500
@@ -50,7 +50,7 @@
 // of itemdata. The function should take a form as follows:
 //    itemdata *itemDataRead(STORAGE_SET *set)
 void item_add_type(const char *type, 
-		   void *new,    void *delete,
+		   void *newfunc,void *deleter,
 		   void *copyTo, void *copy, 
 		   void *store,  void *read);
 
diff -ruN ../nakedmudv3.7/src/items/portal.c src/items/portal.c
--- ../nakedmudv3.7/src/items/portal.c	2008-12-06 00:20:20.000000000 -0500
+++ src/items/portal.c	2009-03-02 01:00:38.000000000 -0500
@@ -101,6 +101,13 @@
   return data->dest;
 }
 
+const char *portalGetSmartDest(OBJ_DATA *obj) {
+  PORTAL_DATA *data = objGetTypeData(obj, "portal");
+  if(objGetRoom(obj))
+    return get_fullkey_relative(data->dest, get_key_locale(roomGetClass(objGetRoom(obj))));
+  return get_fullkey_relative(data->dest, get_key_locale(objGetClass(obj)));
+}
+
 const char *portalGetLeaveMssg(OBJ_DATA *obj) {
   PORTAL_DATA *data = objGetTypeData(obj, "portal");
   return data->leave_mssg;
@@ -144,9 +151,10 @@
 
   // we're trying to enter a portal
   if(!objIsType(obj, "portal"))
-    send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+    send_to_char(ch, "You cannot seem to find an entrance.\r\n");
   else {
-    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(obj));
+    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetSmartDest(obj));
+    //get_fullkey_relative(portalGetDest(obj), get_key_locale(objGetClass(obj))));
     if(dest == NULL)
       send_to_char(ch, "There is nothing on the other side...\r\n");
     else {
@@ -165,6 +173,7 @@
       else
 	message(ch, NULL, obj, NULL, TRUE, TO_ROOM,
 		"$n arrives after travelling through $o.");
+      hookRun("enter_portal", hookBuildInfo("ch obj", ch, obj));
       hookRun("enter", hookBuildInfo("ch rm", ch, dest));
     }
   }
@@ -245,7 +254,7 @@
   if(obj == NULL)
     return NULL;
   else if(objIsType(obj, "portal"))
-    return Py_BuildValue("s", portalGetDest(obj));
+    return Py_BuildValue("s", portalGetSmartDest(obj));
   else {
     PyErr_Format(PyExc_TypeError, "Can only get destination for portals.");
     return NULL;
@@ -358,9 +367,10 @@
   hookParseInfo(info, &obj, &ch);
 
   if(objIsType(obj, "portal")) {
-    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(obj));
+    ROOM_DATA *dest = worldGetRoom(gameworld, portalGetSmartDest(obj));
+    //get_fullkey_relative(portalGetDest(obj), get_key_locale(objGetClass(obj))));
     if(dest != NULL) {
-      send_to_char(ch, "You peer inside %s.\r\n", see_obj_as(ch, obj));
+      send_to_char(ch, "You peer inside %s:\r\n\r\n", see_obj_as(ch, obj));
       look_at_room(ch, dest);
     }
   }
diff -ruN ../nakedmudv3.7/src/items/worn.c src/items/worn.c
--- ../nakedmudv3.7/src/items/worn.c	2008-12-06 00:20:20.000000000 -0500
+++ src/items/worn.c	2009-03-02 12:39:03.000000000 -0500
@@ -126,7 +126,7 @@
 }
 
 WORN_DATA *wornDataRead(STORAGE_SET *set) {
-  WORN_DATA *data = newWornData();
+  WORN_DATA *data = malloc(sizeof(WORN_DATA));
   data->type = strdup(read_string(set, "type"));
   return data;
 }
@@ -231,6 +231,18 @@
 //*****************************************************************************
 // python extentions
 //*****************************************************************************
+PyObject *PyObj_getwornlocs(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "worn"))
+    return Py_BuildValue("s", wornGetPositions(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get wornlocs for wearable items.");
+    return NULL;
+  }
+}
+
 PyObject *PyObj_getworntype(PyObject *self, void *closure) {
   OBJ_DATA *obj = PyObj_AsObj(self);
   if(obj == NULL)
@@ -317,17 +329,18 @@
   hookAdd("append_obj_desc", append_worn_hook);
 
   // add our new python get/setters
+  PyObj_addGetSetter("worn_locs", PyObj_getwornlocs, NULL,
+		     "The positions this item must be equipped to.");
   PyObj_addGetSetter("worn_type", PyObj_getworntype, PyObj_setworntype,
 		     "The type of clothing this wearable item is.");
   PyMudSys_addMethod("add_worn_type", PyMudSys_AddWornType, METH_VARARGS,
 		     "Adds a new worn type to the game.");
   
   // add in our basic worn types
+  worn_add_type("shirt",              "torso, arm, arm");
   /*
     Removed as of v3.3 -- These can now be added via Python with the function,
     mudsys.add_worn_type(<type>, <position list>)
-
-  worn_add_type("shirt",                        "torso");
   worn_add_type("gloves",       "left hand, right hand");
   worn_add_type("left glove",               "left hand");
   worn_add_type("right glove",             "right hand");
diff -ruN ../nakedmudv3.7/src/list.c src/list.c
--- ../nakedmudv3.7/src/list.c	2008-05-31 00:17:59.000000000 -0400
+++ src/list.c	2009-03-02 01:00:38.000000000 -0500
@@ -39,7 +39,7 @@
   LIST_NODE *tail;         // last element in the list
   int size;                // how many elements are in the list?
   int iterators;           // how many iterators are going over us?
-  int remove_pending;      // do we have to do a remove when the iterators die?
+  char remove_pending;     // do we have to do a remove when the iterators die?
 };
 
 
@@ -258,7 +258,7 @@
   return FALSE;
 };
 
-void *listRemoveNum(LIST *L, int num) {
+void *listRemoveNum(LIST *L, unsigned int num) {
   void *elem = listGet(L, num);
   if(elem) listRemove(L, elem);
   return elem;
@@ -268,9 +268,9 @@
   return L->size;
 }
 
-void *listGet(LIST *L, int num) {
+void *listGet(LIST *L, unsigned int num) {
   LIST_NODE *node = L->head;
-  int i;
+  unsigned int i;
 
   // move up to our first non-removed node
   while(node && node->removed)
diff -ruN ../nakedmudv3.7/src/list.h src/list.h
--- ../nakedmudv3.7/src/list.h	2008-05-31 00:17:59.000000000 -0400
+++ src/list.h	2009-03-02 01:00:38.000000000 -0500
@@ -25,7 +25,7 @@
 //
 // Delete an existing list
 //
-void deleteList();
+void deleteList(LIST *L);
 
 
 //
@@ -65,7 +65,7 @@
 // Remove the element in the list at the specified place,
 // and return it
 //
-void *listRemoveNum(LIST *L, int num);
+void *listRemoveNum(LIST *L, unsigned int num);
 
 
 //
@@ -94,7 +94,7 @@
 //
 // get the element with the specific number
 //
-void *listGet(LIST *L, int num);
+void *listGet(LIST *L, unsigned int num);
 
 
 //
diff -ruN ../nakedmudv3.7/src/map.c src/map.c
--- ../nakedmudv3.7/src/map.c	2008-05-31 00:17:59.000000000 -0400
+++ src/map.c	2009-03-02 01:00:38.000000000 -0500
@@ -23,10 +23,8 @@
   return val;
 }
 
-int gen_hash_func(const void *key) {
-  int val = (int)key;
-  if(val < 0) return -val;
-  else        return  val;
+unsigned long gen_hash_func(const void *key) {
+  return (unsigned long)key;
 }
 
 struct map_iterator {
@@ -44,8 +42,8 @@
   int size;
   int num_buckets;
   struct list **buckets;
-  int (* hash_func)(const void *key);
-  int (*  compares)(const void *key1, const void *key2);
+  unsigned long (* hash_func)(const void *key);
+  int           (*  compares)(const void *key1, const void *key2);
 };
 
 
@@ -53,18 +51,18 @@
 // an internal form of hashGet that returns the entire entry (key and val)
 //
 MAP_ENTRY *mapGetEntry(MAP *map, const void *key) {
-  int bucket = map->hash_func(key) % map->num_buckets;
+  unsigned int bucket = map->hash_func(key) % map->num_buckets;
 
   if(map->buckets[bucket] == NULL)
     return NULL;
   else {
-    struct list_iterator *list_i = newListIterator(map->buckets[bucket]);
-    MAP_ENTRY *elem   = NULL;
+    LIST_ITERATOR *list_i = newListIterator(map->buckets[bucket]);
+    MAP_ENTRY     *elem   = NULL;
 
-    for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
+    ITERATE_LIST(elem, list_i) {
       if(!map->compares(key, elem->key))
 	break;
-    deleteListIterator(list_i);
+    } deleteListIterator(list_i);
 
     return elem;
   }
@@ -92,9 +90,9 @@
     if(map->buckets[i] == NULL) continue;
     LIST_ITERATOR *list_i = newListIterator(map->buckets[i]);
     MAP_ENTRY       *elem = NULL;
-    for(;(elem=listIteratorCurrent(list_i)) != NULL;listIteratorNext(list_i))
+    ITERATE_LIST(elem, list_i) {
       listPut(list, elem);
-    deleteListIterator(list_i);
+    } deleteListIterator(list_i);
   }
   return list;
 }
@@ -121,7 +119,7 @@
 
   // now, we put all of our entries back into the new buckets
   while((entry = listPop(entries)) != NULL) {
-    int bucket = map->hash_func(entry->key) % map->num_buckets;
+    unsigned int bucket = map->hash_func(entry->key) % map->num_buckets;
     if(map->buckets[bucket] == NULL) map->buckets[bucket] = newList();
     listPut(map->buckets[bucket], entry);
   }
@@ -136,20 +134,21 @@
 // documentation found in map.h
 //
 //*****************************************************************************
-MAP *newMap(void *hash_func, void *compares) {
-  int i;
+MAP *newMapSize(void *hash_func, void *compares, int size) {
   MAP *map = malloc(sizeof(MAP));
   map->size        = 0;
-  map->num_buckets = DEFAULT_MAP_SIZE;
+  map->num_buckets = size;
   map->hash_func   = (hash_func ? hash_func : gen_hash_func);
   map->compares    = (compares  ? compares  : gen_hash_cmp);
-  map->buckets = malloc(sizeof(LIST *) * map->num_buckets);
-  for(i = 0; i < map->num_buckets; i++)
-    map->buckets[i] = NULL;
+  map->buckets     = calloc(map->num_buckets, sizeof(LIST *));
   return map;
 }
 
-void  deleteMap(MAP *map) {
+MAP *newMap(void *hash_func, void *compares) {
+  return newMapSize(hash_func, compares, DEFAULT_MAP_SIZE);
+}
+
+void deleteMap(MAP *map) {
   int i;
   for(i = 0; i < map->num_buckets; i++) {
     if(map->buckets[i])
@@ -159,20 +158,18 @@
   free(map);
 }
 
-int  mapPut    (MAP *map, const void *key, void *val) {
+int mapPut(MAP *map, const void *key, void *val) {
   MAP_ENTRY *elem = mapGetEntry(map, key);
 
   // update the val if it's already here
-  if(elem) {
+  if(elem)
     elem->val = val;
-    return 1;
-  }
   else {
     // first, see if we'll need to expand the map
     if((map->size * 80)/100 > map->num_buckets)
       mapExpand(map, (map->num_buckets * 150)/100);
 
-    int bucket = map->hash_func(key) % map->num_buckets;
+    unsigned int bucket = map->hash_func(key) % map->num_buckets;
 
     // if the bucket doesn't exist yet, create it
     if(map->buckets[bucket] == NULL)
@@ -181,11 +178,12 @@
     MAP_ENTRY *entry = newMapEntry(key, val);
     listPut(map->buckets[bucket], entry);
     map->size++;
-    return 1;
   }
+
+  return 1;
 }
 
-void *mapGet    (MAP *map, const void *key) {
+void *mapGet(MAP *map, const void *key) {
   MAP_ENTRY *elem = mapGetEntry(map, key);
   if(elem)
     return elem->val;
@@ -193,41 +191,41 @@
     return NULL;
 }
 
-void *mapRemove (MAP *map, const void *key) {
-  int bucket = map->hash_func(key) % map->num_buckets;
+void *mapRemove(MAP *map, const void *key) {
+  unsigned int bucket = map->hash_func(key) % map->num_buckets;
 
   if(map->buckets[bucket] == NULL)
     return NULL;
   else {
-    struct list_iterator *list_i = newListIterator(map->buckets[bucket]);
-    MAP_ENTRY *elem   = NULL;
+    LIST_ITERATOR *list_i = newListIterator(map->buckets[bucket]);
+    MAP_ENTRY       *elem = NULL;
 
-    for(;(elem = listIteratorCurrent(list_i)) != NULL; listIteratorNext(list_i))
+    ITERATE_LIST(elem, list_i) {
       if(!map->compares(key, elem->key))
 	break;
-    deleteListIterator(list_i);
+    } deleteListIterator(list_i);
 
-    if(elem) {
-      void *val = elem->val;
-      listRemove(map->buckets[bucket], elem);
-      deleteMapEntry(elem);
-      map->size--;
-      return val;
-    }
-    else
+    if(elem == NULL)
       return NULL;
+
+    void *val = elem->val;
+    listRemove(map->buckets[bucket], elem);
+    deleteMapEntry(elem);
+    map->size--;
+    return val;
   }
 }
 
-int   mapIn     (MAP *map, const void *key) {
+int mapIn(MAP *map, const void *key) {
   return (mapGetEntry(map, key) != NULL);
 }
 
-int   mapSize   (MAP *map) {
+int mapSize(MAP *map) {
   return map->size;
 }
 
 
+
 //*****************************************************************************
 //
 // implementation of the hashmap iterator
diff -ruN ../nakedmudv3.7/src/map.h src/map.h
--- ../nakedmudv3.7/src/map.h	2008-05-31 00:17:59.000000000 -0400
+++ src/map.h	2009-03-02 01:00:38.000000000 -0500
@@ -16,14 +16,15 @@
 // functions are used.
 //
 // hash_func is expected to be a function that takes the key type used in
-// this map, and returns an integer based on that key.
+// this map, and returns a long value based on that key.
 //
 // compares is expected to be a function that takes two keys and compares
 // them togher. If they are equal, 0 is returned. if key1 is less than key2,
 // -1 is returned. otherwise, 1 is returned. If this function is NULL, a
 // generic comparator is used that compares memory address of the two keys.
-MAP *newMap(void *hash_func, void *compares);
-void deleteMap(MAP *map);
+MAP     *newMap(void *hash_func, void *compares);
+MAP *newMapSize(void *hash_func, void *compares, int size);
+void  deleteMap(MAP *map);
 
 int   mapPut    (MAP *map, const void *key, void *val);
 void *mapGet    (MAP *map, const void *key);
diff -ruN ../nakedmudv3.7/src/mud.c src/mud.c
--- ../nakedmudv3.7/src/mud.c	2008-05-31 00:17:59.000000000 -0400
+++ src/mud.c	2009-03-02 01:00:38.000000000 -0500
@@ -24,6 +24,19 @@
 // our storage set of mud settings
 STORAGE_SET *settings = NULL;
 
+//
+// for generating unique IDs to characters, rooms, objects, exits, etc
+int next_available_uid = START_UID;
+int next_uid(void) {
+  return next_available_uid++;
+}
+
+int top_uid(void) {
+  if(next_available_uid == START_UID)
+    return NOTHING;
+  return next_available_uid - 1;
+}
+
 
 
 //*****************************************************************************
diff -ruN ../nakedmudv3.7/src/mud.h src/mud.h
--- ../nakedmudv3.7/src/mud.h	2008-05-31 00:17:59.000000000 -0400
+++ src/mud.h	2009-03-02 01:00:38.000000000 -0500
@@ -83,6 +83,7 @@
 #include "bitvector.h"
 #include "parse.h"
 #include "command.h"
+#include "filebuf.h"
 
 
 
@@ -108,8 +109,8 @@
 #define SECONDS             SECOND                /* same as above */
 #define MINUTE              * 60 SECONDS          /* one minute */
 #define MINUTES             MINUTE
-#define MAX_INPUT_LEN      1024                   /* max length of a string someone can input */
-#define SMALL_BUFFER       1024
+#define MAX_INPUT_LEN      2048                   /* max length of a string someone can input */
+#define SMALL_BUFFER       2048
 #define MAX_BUFFER         8192                   /* seems like a decent amount         */
 #define MAX_SCRIPT         16384                  /* max length of a script */
 #define MAX_OUTPUT         8192                   /* well shoot me if it isn't enough   */
@@ -127,8 +128,6 @@
 #define TSTATE_CLOSED          3  /* Closed, ready to be recycled.   */
 
 /* Communication Ranges */
-#define COMM_LOCAL             0  /* same room only                  */
-#define COMM_GLOBAL            1  /* all over the game               */
 #define COMM_LOG              10  /* admins only                     */
 
 // these are there UIDs for things that have not yet been created
@@ -136,7 +135,7 @@
 #define NOTHING              (-1)
 #define NOWHERE              (-1)
 
-#define SOMWHERE        "somewhere"
+#define SOMEWHERE       "somewhere"
 #define SOMETHING       "something"
 #define SOMEONE         "someone"
 #define NOTHING_SPECIAL "you see nothing special."
@@ -154,7 +153,7 @@
 //*****************************************************************************
 void init_commands();
 void show_commands(CHAR_DATA *ch, const char *user_groups);
-void remove_cmd   (const char *cmd);
+CMD_DATA *remove_cmd(const char *cmd);
 void add_cmd      (const char *cmd, const char *sort_by, COMMAND(func),
 	           const char *user_group, bool interrupts);
 void add_py_cmd   (const char *cmd, const char *sort_by, void *pyfunc,
@@ -190,6 +189,12 @@
 long        mudsettingGetLong  (const char *key);
 bool        mudsettingGetBool  (const char *key);
 
+//
+// returns the next available UID for mobs, objs, room, exits
+#define START_UID      1000000
+int next_uid(void);
+int  top_uid(void);
+
 
 
 //*****************************************************************************
@@ -200,9 +205,17 @@
 extern  LIST             *mobile_list; // all mobiles currently in the game
 extern  LIST               *room_list; // all rooms currently in the game
 
+extern  SET               *object_set; // objects, set form
+extern  SET               *mobile_set; // mobiles, set form
+extern  SET                 *room_set; // rooms, set form
+
 extern  LIST          *mobs_to_delete; // mobs/objs/rooms that have had
 extern  LIST          *objs_to_delete; // extraction and now need 
 extern  LIST         *rooms_to_delete; // extract_final
+extern  LIST          *strs_to_delete; // strings we didn't want deleted at 
+                                       // the time, but do now. This is for
+                                       // get_fullkey and see_xxx_as
+extern  LIST          *bufs_to_delete; // same for buffers
 
 extern  PROPERTY_TABLE     *mob_table; // a mapping between uid and mob
 extern  PROPERTY_TABLE     *obj_table; // a mapping between uid and obj
@@ -269,6 +282,11 @@
 void  page_continue         ( SOCKET_DATA *dsock);
 void  page_back             ( SOCKET_DATA *dsock);
 
+// socket stuff
+#define charHasSplitScreen(ch)   (charGetInt(ch, "splitscreen") == TRUE)
+#define charGetPageLen(ch)       NUM_LINES_PER_PAGE
+#define charGetPageWidth(ch)     80
+
 //
 // adds a new input handler onto the stack that allows a person to read 
 // long pages of text (e.g. helpfiles in OLC)
diff -ruN ../nakedmudv3.7/src/near_map.c src/near_map.c
--- ../nakedmudv3.7/src/near_map.c	2008-05-31 00:17:59.000000000 -0400
+++ src/near_map.c	2009-03-02 01:00:38.000000000 -0500
@@ -55,7 +55,6 @@
   free(elem);
 }
 
-
 //
 // returns the bucket that the key should map into
 int get_nearmap_bucket(const char *key) {
@@ -152,17 +151,31 @@
     NEAR_MAP_ELEM   *elem = NULL;
     ITERATE_LIST(elem, elem_i) {
       if(startswith(elem->key, key))
-	listQueue(matches, elem->data);
+	// changed to return keys instead of vals, 
+	// so this is a little more intuitive (if not a little slower)
+	listQueue(matches, strdup(elem->key)); // elem->data);
     } deleteListIterator(elem_i);
-    // did we find something?
+
+    // did we not find anything?
     if(listSize(matches) == 0) {
       deleteList(matches);
       matches = NULL;
     }
+
     return matches;
   }
 }
 
+// how big are we?
+int nearMapSize(NEAR_MAP *map) {
+  int size = 0, i;
+  for(i = 0; i < NUM_NEAR_MAP_BUCKETS; i++) {
+    if(map->bucket[i] != NULL)
+      size += listSize(map->bucket[i]);
+  }
+  return size;
+}
+
 
 
 //*****************************************************************************
diff -ruN ../nakedmudv3.7/src/near_map.h src/near_map.h
--- ../nakedmudv3.7/src/near_map.h	2008-05-31 00:17:59.000000000 -0400
+++ src/near_map.h	2009-03-02 01:00:38.000000000 -0500
@@ -25,6 +25,7 @@
 bool       nearMapKeyExists(NEAR_MAP *map, const char *key);
 void         *nearMapRemove(NEAR_MAP *map, const char *key);
 LIST  *nearMapGetAllMatches(NEAR_MAP *map, const char *key);
+int             nearMapSize(NEAR_MAP *map);
 
 
 
